; Image  NEF To JPG Converter And Batch NEF to JPG Converter V1.0
; Copyright (c) 2009 Mike Mclain
; mamclain@gmail.edu
; For Mr. Anderson
; I think he owes me some lunch for this lovely piece of code!
; Note this file needs ufraw from http://sourceforge.net/project/platformdownload.php?group_id=127649&sel_platform=3514 to work


; This function is the generic NEF to JPG function
(define (NEFtoJPG infile outpath filename)
(let*( 
(quality 1)
(smoothing 1)
(optimize 1)
(progressive 0)
(subsampling 0)
(baseline 0)
(restart 0)
(dct 0)
(comment "Image  NEF To JPG Converter And Batch NEF to JPG Converter V1.0")
)
(NEFtoJPGAdv infile outpath filename quality smoothing optimize progressive subsampling baseline restart dct comment)
)) 

; This function is the advanced NEF to JPG function
(define (NEFtoJPGAdv infile outpath filename quality smoothing optimize progressive subsampling baseline restart dct comment)
(let*( 
(outfile (string-append "" outpath "\\" filename))
(image (car ( file-ufraw-load RUN-NONINTERACTIVE infile infile) ))
(drawable (car (gimp-image-get-active-layer image)))
)
(file-jpeg-save RUN-NONINTERACTIVE image drawable outfile outfile quality smoothing optimize progressive comment subsampling baseline restart dct)
(gimp-image-delete image)
)) 

; This function is the  NEF to JPG batch function
(define (BatchNEFtoJPG inpath outpath prefix)
(let*( 
(fullinpath (string-append "" inpath "\\*.NEF"))
(fulloutput (string-append "" outpath "\\"))
(filelist (cadr (file-glob fullinpath 1)))
(count 0)
)
(while (not (null? filelist))
	(let* (
	(filename (car filelist))
	(outfilename (string-append "" prefix (number->string count) ".JPG"))
	)
	(NEFtoJPG filename fulloutput outfilename)
	(set! filelist (cdr filelist)))
	(set! count (+ count 1))
)
)
) 

; This function is the  ADV NEF to JPG batch function
(define (BatchNEFtoJPGAdv inpath outpath prefix quality smoothing optimize progressive subsampling baseline restart dct comment)
(let*( 
(fullinpath (string-append "" inpath "\\*.NEF"))
(fulloutput (string-append "" outpath "\\"))
(filelist (cadr (file-glob fullinpath 1)))
(count 0)
)
(while (not (null? filelist))
	(let* (
	(filename (car filelist))
	(outfilename (string-append "" prefix (number->string count) ".JPG"))
	)
	(NEFtoJPGAdv filename fulloutput outfilename quality smoothing optimize progressive subsampling baseline restart dct comment)
	(set! filelist (cdr filelist)))
	(set! count (+ count 1))
)
)
) 









; NEF To JPG GUI
(script-fu-register "NEFtoJPG"
		    _"_NEF to JPG"				;
		    "Convert A NEF File to a JPG File."
		    "Mike Mclain <mamclain@uncc.edu>"
		    "Mike Mclain"
		    "08/19/08"
		    ""
			SF-FILENAME    "Input NEF File" "" 
			SF-DIRNAME     "Output JPG Folder" ""
			SF-STRING	   "Output JPG File Name" "File.JPG"
)		
(script-fu-menu-register "NEFtoJPG" "<Image>/Scripts/NEF")

; ADV NEF TO JPG GUI
(script-fu-register "NEFtoJPGAdv"
		    _"NEF to Advanced _JPG"				;
		    "Convert A NEF File to a JPG File with Advanced JPG Options."
		    "Mike Mclain <mamclain@uncc.edu>"
		    "Mike Mclain"
		    "08/19/08"
		    ""
			SF-FILENAME    "Input NEF File" "" 
			SF-DIRNAME     "Output JPG Folder" ""
			SF-STRING	   "Output JPG File Name" "File.JPG"		
			SF-ADJUSTMENT "JPG Quality" '(1 0 1 .1 .1 1 SF-SLIDER) 
			SF-ADJUSTMENT "JPG Smoothing" '(1 0 1 .1 .1 1 SF-SLIDER) 
			SF-TOGGLE "JPG Optimization" TRUE
			SF-TOGGLE "JPG Progressive Image Loading" FALSE
			SF-OPTION "JPG Subsampling Rate" '("1x1,1x1,1x1 (best quality)" "2x1,1x1,1x1 (4:2:2)" "1x2,1x1,1x1" "2x2,1x1,1x1 (smallest file)") 
			SF-TOGGLE "JPG Make Baseline" FALSE
			SF-ADJUSTMENT "JPG Restart Markers" '(0 0 1000 1 1 0 SF-SLIDER)
			SF-OPTION "JPG DCT Algorithm " '("Integer" "Floating Point" "Fast Integer") 
			SF-STRING "Comment" "Image  NEF To JPG Converter And Batch NEF to JPG Converter V1.0"
)
(script-fu-menu-register "NEFtoJPGAdv" "<Image>/Scripts/NEF")

; BATCH NEF TO JPG GUI
(script-fu-register "BatchNEFtoJPG"
		    _"_Batch NEF to JPG"				;
		    "Converts NEF Files to JPG Files."
		    "Mike Mclain <mamclain@uncc.edu>"
		    "Mike Mclain"
		    "08/19/08"
		    ""
			SF-DIRNAME     "Input NEF Folder" ""
			SF-DIRNAME     "Output JPG Folder" ""
			SF-STRING	   "Output JPG File Prefix(File__#.JPG)" "File_"
)		
(script-fu-menu-register "BatchNEFtoJPG" "<Image>/Scripts/NEF")


; ADV BATCH NEF TO JPG GUI
(script-fu-register "BatchNEFtoJPGAdv"
		    _"Batch NEF to _Advanced JPG"				;
		    "Converts NEF Files to JPG Files with Advanced JPG Options."
		    "Mike Mclain <mamclain@uncc.edu>"
		    "Mike Mclain"
		    "08/19/08"
		    ""
			SF-DIRNAME     "Input NEF Folder" ""
			SF-DIRNAME     "Output JPG Folder" ""
			SF-STRING	   "Output JPG File Prefix(File__#.JPG)" "File_"	
			SF-ADJUSTMENT "JPG Quality" '(1 0 1 .1 .1 1 SF-SLIDER) 
			SF-ADJUSTMENT "JPG Smoothing" '(1 0 1 .1 .1 1 SF-SLIDER) 
			SF-TOGGLE "JPG Optimization" TRUE
			SF-TOGGLE "JPG Progressive Image Loading" FALSE
			SF-OPTION "JPG Subsampling Rate" '("1x1,1x1,1x1 (best quality)" "2x1,1x1,1x1 (4:2:2)" "1x2,1x1,1x1" "2x2,1x1,1x1 (smallest file)") 
			SF-TOGGLE "JPG Make Baseline" FALSE
			SF-ADJUSTMENT "JPG Restart Markers" '(0 0 1000 1 1 0 SF-SLIDER)
			SF-OPTION "JPG DCT Algorithm " '("Integer" "Floating Point" "Fast Integer") 
			SF-STRING "Comment" "Image  NEF To JPG Converter And Batch NEF to JPG Converter V1.0"
)
(script-fu-menu-register "BatchNEFtoJPGAdv" "<Image>/Scripts/NEF")


			
			
		


